#include <amxmodx>
#include <amxmisc>
#include <fakemeta>
#include <engine>

#define PLUGIN "Kaboom!"
#define VERSION "1.0"
#define AUTHOR "R3X"

new const gszModels[][] = {
	"w_hegrenade.mdl",
	"w_flashbang.mdl"
};


new gcvarEnabled;
public plugin_init() {
	register_plugin(PLUGIN, VERSION, AUTHOR);
	
	register_touch("*", "grenade", "fwTouchGrenade2");
	register_touch("grenade", "*", "fwTouchGrenade");
	
	gcvarEnabled = register_cvar("amx_kaboom", "1");
}

public fwTouchGrenade2(ent, nade){
	fwTouchGrenade(nade);
}

public fwTouchGrenade(nade){
	if(!get_pcvar_num(gcvarEnabled)) return;
	
	new szModel[32];
	pev(nade, pev_model, szModel, 31);
	
	for(new i=0;i<sizeof(gszModels); i++)
		if(equal(szModel[7], gszModels[i])){
			set_pev(nade, pev_dmgtime, get_gametime());
			dllfunc(DLLFunc_Think, nade);
			break;
		}
}